/*
 * The contents of this file are subject to the Mozilla Public License Version 1.1
 * (the "License"); you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://www.mozilla.org/MPL/>.
 * 
 * Software distributed under the License is distributed on an "AS IS" basis, WITHOUT
 * WARRANTY OF ANY KIND, either express or implied. See the License for the specific
 * language governing rights and limitations under the License.
 * 
 * The Original Code is the Venice Web Communities System.
 * 
 * The Initial Developer of the Original Code is Eric J. Bowersox <erbo@silcom.com>,
 * for Silverwrist Design Studios.  Portions created by Eric J. Bowersox are
 * Copyright (C) 2003 Eric J. Bowersox/Silverwrist Design Studios.  All Rights Reserved.
 * 
 * Contributor(s): 
 */
package com.silverwrist.venice.iface;

import java.util.Set;
import com.silverwrist.dynamo.except.DatabaseException;

public interface MenuEditObject
{
  public String getTitle();

  public void setTitle(String title) throws DatabaseException;

  public String getSubtitle();

  public void setSubtitle(String subtitle) throws DatabaseException;

  public Set getVariables();

  public String getDefaultVal(String variable);

  public void setDefaultVal(String variable, String value) throws DatabaseException;

  public void addVariable(String variable, String value) throws DatabaseException;

  public void removeVariable(String variable) throws DatabaseException;

  public int getItemCount();

  public MenuEditItemObject getItem(int ndx);

  public MenuEditItemObject getItemBySequence(int seq);

  public MenuEditItemObject getItemByTypeText(String type, String text);

  public MenuEditItemObject getItemContainingLinkText(String text);

  public MenuEditItemObject getNextItem(MenuEditItemObject obj);

  public MenuEditItemObject getPreviousItem(MenuEditItemObject obj);

  public MenuEditItemObject addItem(String type, int sequence, String text, String linktype, String link)
      throws DatabaseException;

  public void delete() throws DatabaseException;

} // end interface MenuEditObject
